#include <openssl/bio.h>
#include <openssl/evp.h>

#include <string.h>
#include "base64.h"

unsigned char *base64_decode(unsigned char *input)
{
	BIO *bio, *b64, *bio_out;
	unsigned char *outptr;
	unsigned char *output;
	unsigned char *inbuf[512];
	long outlen = -1;
	int inlen;

	b64 = BIO_new(BIO_f_base64());
	bio = BIO_new(BIO_s_mem());
	bio_out = BIO_new(BIO_s_mem());
	BIO_set_flags(b64, BIO_FLAGS_BASE64_NO_NL);

	BIO_puts(bio, (char *)input);

	bio = BIO_push(b64, bio);

	while((inlen = BIO_read(bio, inbuf, 512)) > 0)
	{
		BIO_write(bio_out, inbuf, inlen);
	}

	outlen = BIO_get_mem_data(bio_out, &outptr);

	output = malloc(outlen+1);
	memcpy(output, outptr, outlen);
	output[outlen] = '\0';

	BIO_free_all(bio);
	BIO_free_all(bio_out);

	return output;
}
