#ifndef OP5_LICENSE_READER_H_
#define OP5_LICENSE_READER_H_
#include <lua.h>
#include "license_error.h"
struct op5lic_reader_t;

struct op5lic_reader_t *op5lic_reader_create(const char *filename, struct op5lic_error_t *err);
void op5lic_reader_destroy(struct op5lic_reader_t *lr);

/*
 * Load a v1/v2 XML license and transform it into a set of equivalent in-memory lua rules.
 */
LicenseStatus op5lic_reader_load_v1_v2_fallback(const char *filename, lua_State *L, struct op5lic_error_t *err);
/*
 * Load the lua script license content from the supplied license reader into the
 * supplied lua_State
 * @param lr The license reader
 * @param L The lua state
 * @return A status code
 *
 */
LicenseStatus op5lic_reader_load_lua(struct op5lic_reader_t *lr, lua_State *L, struct op5lic_error_t *err);

#endif
